<?php

namespace NoccyLabs\React\Http2\Connection;

use Evenement\EventEmitterInterface;
use Evenement\EventEmitterTrait;
use NoccyLabs\React\Http2\Stream\Http2Stream;
use React\Stream\DuplexStreamInterface;

/**
 * HTTP/2 Connecton Classs
 * 
 * 
 */
class Http2Connection implements EventEmitterInterface
{
    use EventEmitterTrait;

    /** @var string Emitted when a new stream is opened */
    const EVENT_OPEN = 'open';

    /** @var string Emitted when a the connection (and effectively all its streams) are closed */
    const EVENT_CLOSE = 'close';

    /** @var array<int,Http2Stream> The active streams, even for s2c, odd for c2s */
    private array $streams = [];

    /** @var int The last used stream identifier */
    private int $lastStream = 0;

    /** @var int Max number of streams that can be opened; assigned from settings frame */
    private int $maxStream = 0;

    /** @var DuplexStreamInterface The connection to the client */
    private DuplexStreamInterface $connection;

    public function __construct(DuplexStreamInterface $connection)
    {
        $this->connection = $connection;

        
    }

    /**
     * When a new stream is opened, clean up older streams that are idle or closed.
     * 
     * @return void
     */
    private function doStreamHouseKeeping(): void
    {

    }
}